BEGIN {	FS = "," } 
 {
	print "#define THIS_HOUSE_ID \\b"$(n_id)
	print "#define THIS_HOUSE_ID2 \\b"$(n_id)+1
	print "#define THIS_HOUSE_ID3 \\b"$(n_id)+2
	print "#define THIS_HOUSE_ID4 \\b"$(n_id)+3
	print "#define THIS_HOUSE_TYPE \\b"$(n_type)
	print "#define THIS_HOUSE_TYPE2 \\b"$(n_type)+1
	print "#define THIS_HOUSE_TYPE3 \\b"$(n_type)+2
	print "#define THIS_HOUSE_TYPE4 \\b"$(n_type)+3
	print "#define THIS_HOUSE_AVAIL_MASK "$(n_avail_mask)
	printf "#define THIS_HOUSE_FLAGS %02X\n",get_flags($(n_flags))
	print "#define THIS_HOUSE_CHANCE "bin2hex($(n_chance))
	print "#define THIS_HOUSE_GEN_POP \\b"int($(n_gen_pop))
	print "#define THIS_HOUSE_GEN_MAIL \\b"int($(n_gen_mail))
	print "#define THIS_HOUSE_ACC_POP \\b"int($(n_acc_pop))
	print "#define THIS_HOUSE_ACC_MAIL \\b"int($(n_acc_mail))
	print "#define THIS_HOUSE_ACC_GOODS "$(n_acc_goods)	# This must not be converted from decimal to hex. It is already in hex.
	print "#define THIS_HOUSE_CARGOS "$(n_cargos)
	print "#define THIS_HOUSE_STARTYEAR \\w"int($(n_startyear))
	print "#define THIS_HOUSE_LASTYEAR \\w"int($(n_lastyear))
	printf "#define THIS_HOUSE_AVAIL_YEAR %s\n", get_shortyear($(n_startyear),$(n_lastyear))
	printf "#define THIS_HOUSE_STRID \\wxDC%02X\n",$(n_id)
	print "#define THIS_HOUSE_PCX sprites/pcx/"remove_white($(n_pcx))".pcx"
	print "#include \""remove_white($(n_template))"\"" 
}

function bin2hex(bin) {
	return sprintf("%02X",bin)
}

function get_shortyear(start, end) {
	a0start = start > 1920 ? (start < 2070 ? start - 1920 : FE) : 00
	a0end   = end > 1920 ? (end < 2070 ? end - 1920 : FF) : 01
	return sprintf("%02X %02X", a0start, a0end)
}

function remove_white(string) {
	sub(/[	]+$/,"",string)
	sub(/^[ 	]+|[	]+$/,"",string)
	return string
}

function get_flags(string) {
	string = tolower(string)
	flags = 0 
	flags += (index(string,"t1x1") != 0) * 01
	flags += (index(string,"t2x2") != 0) * 16
	flags += (index(string,"church") != 0) * 16 * 4
	flags += (index(string,"stadion") != 0) * 16 * 8
	flags += (index(string,"flat") != 0) * 2
	flags += (index(string,"anim") != 0) * 16 * 2
	flags += (index(string,"t2x1") != 0) * 04
	flags += (index(string,"t1x2") != 0) * 08
	return flags
}