BEGIN {	FS = "," }
{
	mode = tolower(ARGV[2])
	for (i = 0; i < ARGC; i++)
		printf "Argument %d = %s\n", i, ARGV[i]
	fields_stats()
	if (mode == "action0")
		while (getline()) {
			action0()
		}
	else
		usage()
	exit 0
}

function fields_stats() {
	n_id = 1
	n_type = 1                 # Yes, on purpose!
	n_pcx = 2
	n_name = 3
	n_startyear = 4
	n_lastyear  = 5
	n_minlife   = 6
	n_avail_mask = 7 
	n_flags      = 8
	n_chance     = 9
	n_gen_pop    = 10
	n_gen_mail   = 11
	n_acc_pop    = 12
	n_acc_mail   = 13
	n_acc_goods  = 14
	n_cargos     = 15
	n_strid      = 16
	n_template   = 17 
}
function action0() {
	print "#define THIS_HOUSE_ID \\b"$(n_id)
	print "#define THIS_HOUSE_ID2 \\b"$(n_id)+1
	print "#define THIS_HOUSE_ID3 \\b"$(n_id)+2
	print "#define THIS_HOUSE_ID4 \\b"$(n_id)+3
	print "#define THIS_HOUSE_TYPE "$(n_type)
	print "#define THIS_HOUSE_TYPE2 "$(n_type)+1
	print "#define THIS_HOUSE_TYPE3 "$(n_type)+2
	print "#define THIS_HOUSE_TYPE4 "$(n_type)+3
	print "#define THIS_HOUSE_AVAIL_MASK "$(n_avail_mask)
	flags = 0 
	flags += (index($(n_flags), "t1x1") != 0) * 01
	flags += (index($(n_flags), "t2x2") != 0) * 16
	flags += (index(tolower($(n_flags)),"church") != 0) * 16 * 4
	flags += (index(tolower($(n_flags)),"stadion") != 0) * 16 * 8
	flags += (index(tolower($(n_flags)),"flat") != 0) * 2
	flags += (index(tolower($(n_flags)),"anim") != 0) * 16 * 2
	printf "#define THIS_HOUSE_FLAGS %x\n",flags
	print "#define THIS_HOUSE_CHANCE "$(n_chance)
	print "#define THIS_HOUSE_GEN_POP \\b"int($(n_gen_pop))
	print "#define THIS_HOUSE_GEN_MAIL "$(n_gen_mail)
	print "#define THIS_HOUSE_ACC_POP "$(n_acc_pop)
	print "#define THIS_HOUSE_ACC_MAIL "$(n_acc_mail)
	print "#define THIS_HOUSE_ACC_GOODS "$(n_acc_goods)
	print "#define THIS_HOUSE_CARGOS "$(n_cargos)
	print "#define THIS_HOUSE_STARTYEAR \\w"int($(n_startyear))
	print "#define THIS_HOUSE_LASTYEAR \\w"int($(n_lastyear))
	a0start = $(n_startyear) > 1920 ? ($(n_startyear) < 2070 ? $(n_startyear) - 1920 : FE) : 00
	a0end   = $(n_lastyear) > 1920 ? ($(n_lastyear) < 2070 ? $(n_lastyear) - 1920 : FF) : 01
	printf "#define THIS_HOUSE_AVAIL_YEAR %x %x\n", a0start, a0end
	print "#define THIS_HOUSE_STRID \\wxDC",$(n_id)
	sub(/[	]+$/,"",$(n_pcx))
	sub(/^[ 	]+|[	]+$/,"",$(n_pcx))
	print "#define THIS_HOUSE_PCX sprites/pcx/"$(n_pcx)".pcx"
	sub(/[	]+$/,"",$(n_template))
	sub(/^[ 	]+|[	]+$/,"",$(n_template))
	print "#include \""$(n_template)"\"" 
}

function usage() {
	print "Usage: "ARGV[0]" mode=<mode> -f <inputfile>"
	print "Where <mode> is one of the following supported modes:"
	print "	action0:	process <inputfile> and generate the action0 from it (assuming stats.list as input)"
	print "	lang:		process <inputfile> and generate lang.pnfo from it (assuming lang.list as input)"
}